/***************************************************************************
 *   Copyright (C) 2003 by Hans Karlsson                                   *
 *   karlsson.h@home.se                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef IMAGELABEL_H
#define IMAGELABEL_H
#include "meter.h"
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>
#include <qstring.h>
#include <qstringlist.h>
#include <kurl.h>
#include <kio/netaccess.h>
#include <qregexp.h>

#include "karamba.h"

class karamba;

class ImageLabel : public Meter
{
public:
  ImageLabel( int ix,int iy,int iw,int ih );
  ImageLabel();
  ~ImageLabel();
  void setValue( QString imagePath );

  void setValue( int );
  void mUpdate( QPainter * );

  void rolloverImage(QMouseEvent *e);
  void parseImages( QString fn, QString fn_roll, int, int, int, int );

  void setKaramba(karamba*);
  void setTooltip(QString txt);

private:

  int pixmapWidth;
  int pixmapHeight;
  int pixmapOffWidth;
  int pixmapOffHeight;
  int pixmapOnWidth;
  int pixmapOnHeight;

  QPixmap pixmap;
  QRect rect_off, rect_on;

  bool zoomed;
  //QString fn, fn_roll;
  bool rollover;
  QPixmap pixmap_off;
  QPixmap pixmap_on;
  int xoff,xon;
  int yoff,yon;
  karamba* myKaramba;
}
;
#endif // IMAGELABEL_H
