#include "karambaconf.h"

/*
 *  Constructs a KarambaConf as a child of Karamba with the
 *  name 'KarambaConf' .
 *
 */
KarambaConf::KarambaConf( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    loadConfig();
    if ( !name ){
      setName( "Karamba_conf" );
    }
    setMinimumSize( QSize( 600, 360 ) );
    setMaximumSize( QSize( 600, 360 ) );
    setSizeGripEnabled( TRUE );

    QWidget* privateLayoutWidget = new QWidget( this, "Layout1" );
    privateLayoutWidget->setGeometry( QRect( 11, 326, 575, 27 ) );
    Layout1 = new QHBoxLayout( privateLayoutWidget, 0, 6, "Layout1"); 

    buttonHelp = new QPushButton( privateLayoutWidget, "buttonHelp" );
    buttonHelp->setAutoDefault( TRUE );
    Layout1->addWidget( buttonHelp );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer );

    buttonOk = new QPushButton( privateLayoutWidget, "buttonOk" );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
    Layout1->addWidget( buttonOk );

    buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
    Layout1->addWidget( buttonCancel );

    QWidget* privateLayoutWidget_2 = new QWidget( this, "layout5" );
    privateLayoutWidget_2->setGeometry( QRect( 5, 0, 590, 320 ) );
    layout5 = new QHBoxLayout( privateLayoutWidget_2, 0, 0, "layout5");

    tabWidget = new QTabWidget( privateLayoutWidget_2, "tabWidget" );
    tabWidget->setEnabled( TRUE );
    tabWidget->setMinimumSize( QSize( 590, 320 ) );
    tabWidget->setMaximumSize( QSize( 590, 320 ) );
    tabWidget->setAutoMask( TRUE );

    Widget2 = new QWidget( tabWidget, "Widget2" );
    QWidget* privateLayoutWidget_3 = new QWidget( Widget2, "layout3" );
    privateLayoutWidget_3->setGeometry( QRect( 10, 10, 570, 280 ) );
    layout3 = new QVBoxLayout( privateLayoutWidget_3, 11, 6, "layout3");

    dFolderGroup = new QGroupBox( privateLayoutWidget_3, "dFolderGroup" );
    dFolderGroup->setGeometry( QRect( 0, 0, 570, 60 ) );

    dFolder = new QLineEdit( dFolderGroup, "dFolder" );
    dFolder->setGeometry( QRect( 20, 20, 250, 22 ) );
    dFolder->setText( Dir );

    browse_1 = new QPushButton( dFolderGroup, "browse_1" );
    browse_1->setGeometry( QRect( 300, 20, 100, 28 ) );
    layout3->addWidget( dFolderGroup );

    dThemeGroup = new QGroupBox( privateLayoutWidget_3, "dThemeGroup" );
    dThemeGroup->setGeometry( QRect( 10, 70, 570, 120 ) );

    dTheme = new QLineEdit( dThemeGroup, "dTheme" );
    dTheme->setGeometry( QRect( 20, 20, 250, 22 ) );
    dTheme->setText( Theme );

    browse_2 = new QPushButton( dThemeGroup, "browse_2" );
    browse_2->setGeometry( QRect( 300, 18, 100, 28 ) );
    themeLabel = new QLabel( dThemeGroup, "themeLabel" );
    themeLabel->setGeometry( QRect( 10, 50, 530, 40 ) );
    layout3->addWidget( dThemeGroup );

    dAppsGroup = new QGroupBox( privateLayoutWidget_3, "dAppsGroup" );
    dAppsGroup->setGeometry( QRect( 10, 200, 570, 50 ) );
    viewerLabel = new QLabel( dAppsGroup, "viewerLabel" );
    viewerLabel->setGeometry( QRect( 20, 20, 170, 22 ) );
    dViewer = new QLineEdit( dAppsGroup, "dViewer" );
    dViewer->setGeometry( QRect( 190, 20, 250, 22 ) );
    dViewer->setText( Viewer );
    browse_3 = new QPushButton( dAppsGroup, "browse_3" );
    browse_3->setGeometry( QRect( 440, 18, 100, 28 ) );
    layout3->addWidget( dAppsGroup );

    tabWidget->insertTab( Widget2, "" );

    Widget3 = new QWidget( tabWidget, "Widget3" );

    CoversGroup = new QGroupBox( Widget3, "CoversGroup" );
    CoversGroup->setGeometry( QRect( 10, 10, 570, 100 ) );

    CoverCheck = new QCheckBox( CoversGroup, "CoverCheck" );
    CoverCheck->setGeometry( QRect( 20, 18, 250, 21 ) );
    CoverCheck->setChecked(EnableCover);

    id3CoverCheck = new QCheckBox( CoversGroup, "id3CoverCheck" );
    id3CoverCheck->setGeometry( QRect( 260, 18, 250, 21 ) );
    id3CoverCheck->setChecked(EnableId3Cover);

    textLabel1 = new QLabel( CoversGroup, "textLabel1" );
    textLabel1->setGeometry( QRect( 20, 50, 250, 21 ) );

    cWidth = new QLineEdit( CoversGroup, "cWidth" );
    cWidth->setGeometry( QRect( 20, 70, 81, 21 ) );
    cWidth->setAlignment (Qt::AlignRight);
    cWidth->setText( QString::number( CoverWidth ) );

    textLabel2 = new QLabel( CoversGroup, "textLabel2" );
    textLabel2->setGeometry( QRect( 260, 50, 250, 21 ) );

    cHeight = new QLineEdit( CoversGroup, "cHeight" );
    cHeight->setGeometry( QRect( 260, 70, 81, 21 ) );
    cHeight->setAlignment (Qt::AlignRight);
    cHeight->setText( QString::number( CoverHeight ) );

    XmmsGroup = new QGroupBox( Widget3, "XmmsGroup" );
    XmmsGroup->setGeometry( QRect( 10, 120, 570, 80 ) );

    mainWinCheck = new QCheckBox( XmmsGroup, "mainWinCheck" );
    mainWinCheck->setGeometry( QRect( 20, 18, 250, 21 ) );
    mainWinCheck->setChecked(HideMainWin);

    tabWidget->insertTab( Widget3, "" );

    Widget4 = new QWidget( tabWidget, "Widget4" );
    QWidget* privateLayoutWidget_4 = new QWidget( Widget4, "layout4" );
    privateLayoutWidget_4->setGeometry( QRect( 10, 10, 570, 250 ) );
    tabWidget2 = new QTabWidget( privateLayoutWidget_4, "tabWidget2" );
    tabWidget2->setEnabled( TRUE );
    tabWidget2->setMinimumSize( QSize( 570, 250 ) );
    tabWidget2->setMaximumSize( QSize( 570, 250 ) );
    tabWidget2->setAutoMask( TRUE );
    Widget5 = new QWidget( tabWidget2, "Widget5" );
    QWidget* privateLayoutWidget_5 = new QWidget( Widget5, "layout5" );
    privateLayoutWidget_5->setGeometry( QRect( 10, 10, 550, 210 ) );
    textLabel3 = new QLabel(privateLayoutWidget_5 , "textLabel3" );
    textLabel3->setGeometry( QRect( 10, 10, 500, 20 ) );
    QFont font;
    font.setBold( true );
    textLabel3->setFont( font );
    textLabel4 = new KActiveLabel(privateLayoutWidget_5 , "textLabel4" );
    textLabel4->setGeometry( QRect( 10, 40, 500, 40 ) );
    Widget6 = new QWidget( tabWidget2, "Widget6" );
    QWidget* privateLayoutWidget_6 = new QWidget( Widget6, "layout6" );
    privateLayoutWidget_6->setGeometry( QRect( 10, 10, 550, 210 ) );
    textEdit1 = new KTextEdit(privateLayoutWidget_6, "textEdit1");
    textEdit1->setGeometry( QRect( 10, 10, 530, 190 ) );
    textEdit1->setReadOnly(true);
    tabWidget2->insertTab( Widget5, "" );
    tabWidget2->insertTab( Widget6, "" );
    tabWidget->insertTab( Widget4, "" );


    layout5->addWidget( tabWidget );
    languageChange();
    resize( QSize(600, 360).expandedTo(minimumSizeHint()) );

    toggleCover();
    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( saveConfig() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( browse_1, SIGNAL( clicked() ), this, SLOT( selThemeDir() ) );
    connect( browse_2, SIGNAL( clicked() ), this, SLOT( selDefaultTheme() ) );
    connect( browse_3, SIGNAL( clicked() ), this, SLOT( selDefaultViewer() ) );
    connect( CoverCheck, SIGNAL( clicked() ), this, SLOT( toggleCover() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KarambaConf::~KarambaConf()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KarambaConf::languageChange()
{
    setCaption( tr2i18n( "Karamba Configuration" ) );
    buttonHelp->setText( tr2i18n( "&Help" ) );
    buttonHelp->setAccel( QKeySequence( tr2i18n( "F1" ) ) );
    buttonOk->setText( tr2i18n( "&OK" ) );
    buttonOk->setAccel( QKeySequence( QString::null ) );
    buttonCancel->setText( tr2i18n( "&Cancel" ) );
    buttonCancel->setAccel( QKeySequence( QString::null ) );
    dFolderGroup->setTitle( tr2i18n( "Default themes folder" ) );
    browse_1->setText( tr2i18n( "Browse" ) );
    dThemeGroup->setTitle( tr2i18n( "Default theme" ) );
    browse_2->setText( tr2i18n( "Browse" ) );
    themeLabel->setText( tr2i18n( "Set your default theme.\nIt will be load at Karamba startup.\nYou can set it null if you want the open dialog." ) );
    dAppsGroup->setTitle( tr2i18n( "Helper applications" ) );
    viewerLabel->setText( tr2i18n( "Default image viewer." ) );
    browse_3->setText( tr2i18n( "Browse" ) );
    tabWidget->changeTab( Widget2, tr2i18n( "Karamba" ) );
    CoversGroup->setTitle( tr2i18n( "Covers" ) );
    CoverCheck->setText( tr2i18n( "Enable cover display" ) );
    id3CoverCheck->setText( tr2i18n( "Enable ID3 cover search" ) );
    textLabel1->setText( tr2i18n( "Max cover width" ) );
    textLabel2->setText( tr2i18n( "Max cover height" ) );
    XmmsGroup->setTitle( tr2i18n( "XMMS" ) );
    mainWinCheck->setText( tr2i18n( "Always hide XMMS main window" ) );
    tabWidget->changeTab( Widget3, tr2i18n( "XMMS Sensor" ) );
    tabWidget->changeTab( Widget4, tr2i18n( "About" ) );
    tabWidget2->changeTab( Widget5, tr2i18n( "About" ) );
    tabWidget2->changeTab( Widget6, tr2i18n( "License" ) );
    static const char *description = I18N_NOOP("A KDE Eye-candy Application");
    static const char *version = "0.17";
    KAboutData about("karamba", I18N_NOOP("karamba"), version, description, KAboutData::License_GPL, "(C) 2003 Hans Karlsson", 0, 0, "karlsson.h@home.se");
    textLabel3->setText( tr2i18n( "Karamba 0.17") );
    textLabel3->setAlignment (Qt::AlignTop);
    textLabel4->setText( KStringHandler::tagURLs(tr2i18n( "A KDE Eye-candy Application\n(C) 2003 Hans Karlsson karlsson.h@home.se\nConfiguration module by Bosselut Cyril bosselut@b1project.com" )));
    textLabel4->setAlignment (Qt::AlignTop);
    textEdit1->setText(about.license());
}

void KarambaConf::loadConfig(){
  KSimpleConfig conf("karambarc",true);
  conf.setGroup("karamba");
  Dir = conf.readEntry("ThemeDir", "/usr/share/apps/karamba/themes/");
  Theme =  conf.readEntry("DefaultTheme", "");
  Viewer =  conf.readEntry("ImgViewer", "");
  conf.setGroup("XMMS");
  EnableCover = conf.readBoolEntry("EnableCover",false);
  EnableId3Cover = conf.readBoolEntry("EnableId3Cover",false);
  CoverWidth = conf.readNumEntry("CoverWidth",64);
  CoverHeight = conf.readNumEntry("CoverHeight",64);
  HideMainWin = conf.readBoolEntry("HideMainWin",false);
}

void KarambaConf::saveConfig(){
  KSimpleConfig conf("karambarc",false);
  conf.setGroup("karamba");
  Dir = conf.readEntry("ThemeDir", dFolder->text());
  conf.writeEntry("DefaultTheme", dTheme->text());
  conf.writeEntry("ImgViewer", dViewer->text());
  conf.setGroup("XMMS");
  if(CoverCheck->isChecked() == true){
    conf.writeEntry("EnableCover", "true");
  }
  else{
    conf.writeEntry("EnableCover", "false");
  }
  if(id3CoverCheck->isChecked() == true){
    conf.writeEntry("EnableId3Cover", "true");
  }
  else{
    conf.writeEntry("EnableId3Cover", "false");
  }
  conf.writeEntry("CoverWidth", cWidth->text());
  conf.writeEntry("CoverHeight", cHeight->text());
  if(mainWinCheck->isChecked() == true){
    conf.writeEntry("HideMainWin", "true");
  }
  else{
    conf.writeEntry("HideMainWin", "false");
  }
  conf.sync();
  accept();
}

void KarambaConf::selThemeDir(){
  KDirSelectDialog dirName;
  KURL ndir;
  ndir = dirName.selectDirectory(Dir, false, 0, "Select default folder");
  if( ndir.path() != ""){
    dFolder->setText( ndir.path() );
  }
}

void KarambaConf::selDefaultTheme(){
    QString fileName;
    fileName = KFileDialog::getOpenFileName(Dir, "*.theme", 0, "Open configurations");
    QUrl url(fileName); //make QUrl from QString
    fileName = (url.dirPath() == Dir)?url.fileName():fileName; //verify if the theme is in default dir
    if( fileName != ""){
      dTheme->setText( fileName );
      Theme = fileName;
    }
}

void KarambaConf::selDefaultViewer(){
    QString fileName;
    fileName = KFileDialog::getOpenFileName(Dir, "*", 0, "Choose image viewer");
    if( fileName != ""){
      dViewer->setText( fileName );
      Viewer = fileName;
    }
}

void KarambaConf::toggleCover(){
  EnableCover = CoverCheck->isChecked();
  cWidth->setEnabled ( EnableCover );
  cHeight->setEnabled ( EnableCover );
  id3CoverCheck->setEnabled ( EnableCover );
}

#include "karambaconf.moc"
